local C = require("classic")
local M = require("menu")

-- This whole script is kinda hacky.. hopefully there will be better ways to
-- do the same thing in the future.

choice_telewand = { -- Menu choice for Wand of Teleportation 
   id = "telewand",
   text = "Wand of Teleportation",
   features = function(S)
      C.add_item(i_wand_of_teleport, S.num_wands, C.item_weights)
   end
}

-- Add wand description
local ref_of_describe_wand = C.describe_wand
local copyof_describe_wand = C.deep_copy(ref_of_describe_wand)

ref_of_describe_wand = function(S)
   if S.wand == "telewand" then 
      return "The Wand of Teleportation can be used to teleport creatures."
   end
   if S.wand == "multi_wands" then
      return ( copyof_describe_wand({wand = "destruction"}) .. "\n" ..
               copyof_describe_wand({wand = "securing"})  )
   end
   return copyof_describe_wand(S) -- All existing wands
end

C.describe_wand = ref_of_describe_wand


-- More functions for working with the menu
function menu_item_exists(id)
   for k,v in ipairs(kts.MENU.items) do
      if v.id == id then
         return true
      end
   end
   return false
end

function menu_choice_exists(item_id, choice_id)
   local item = M.get_menu_item(item_id)
   for k,v in ipairs(item.choices) do
      if v.id == choice_id then
         return true
      end
   end
   return false
end

function add_menu_choice_before(item_id, new_choice, old_choice)
   local item = M.get_menu_item(item_id)
   if menu_choice_exists(item_id, old_choice) then
      local pos
      for k,v in ipairs(item.choices) do
         if v.id == old_choice then
            pos = k
            break
         end
      end
      table.insert(item.choices, pos, new_choice) -- Add before the specified choice
   else
      table.insert(item.choices, new_choice)  -- Add it at the end.
   end
end


-- If multiwand mod is loaded, update the "All Wands" choice to include the new wand aswell.
if menu_choice_exists("wand","all_wands") then
   local ref_of_choice_all_wands = M.get_menu_choice("wand", "all_wands")
   local copyof_choice_all_wands = C.deep_copy(ref_of_choice_all_wands)

   ref_of_choice_all_wands.features = function (S)
      copyof_choice_all_wands.features (S) -- All existing wands
      choice_telewand.features (S) -- And the new one
   end

   add_menu_choice_before("wand", choice_telewand, "multi_wands") -- Add it to the menu item for wands
else
   M.add_menu_choice("wand", choice_telewand) -- Add it to the menu item for wands
end
